; Assembly Source File
; Created 3/6/2002, 4:21:09 PM

;benchmark Copyright 2002 by Greg Dietsche
;Webpage:  http://gforce.calc.org
;E-Mail:   gforce@calc.org

;returns number of loops (18 cycles per loop) executed before ai3 triggers
;the interrupt mask should be set to $200 before executing this routine

;this code will crash VTI 2.5 Beta 5 becaise it does not emulate ai3

;C-Style Prototype: unsigned long benchmark(void);

	section ".data"
	xdef benchmark
	
benchmark:
 lea.l TimeInt(pc),a0		;a0 is for auxiliary use
 move.l $4006C,a1		;a1 is a pointer to the old ai3 exception vector
 clr.l d0			;d0 is the counter
 clr.w d1			;d1 is used for ai3 sync
 
 move.l a0,$4006C
 
 move.b $600015,d2		;save current settings
 move.b #%00010111,$600015	;disable all except ai3

dummy: bra.s dummy		;wait-sync with ai3....

StartTiming:
 addq.l #1,d0			;8 ticks  \  18 clock
 bra.s StartTiming		;10 ticks /   cycles
EndTiming:

 move.l a1,$4006C
 move.b d2,$600015	;restore the previous settings
 rts

TimeInt:
 cmp.w #0,d1			;4
 bne.s TimeIntCont		;18/12?
 move.w #1,d1			;12
 rte				;20
 
TimeIntCont:
 cmp.w #0,d0			;4
 bne.s TimeIntRet2		;18/12?
 
 lea.l StartTiming(pc),a0	;8
 move.l a0,2(sp)		;12
 rte				;20
 
TimeIntRet2:
 lea.l EndTiming(pc),a0		;8
 move.l a0,2(sp)		;12
 rte				;20

